"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _RootRef = _interopRequireDefault(require("@material-ui/core/RootRef"));

var _Snackbar = _interopRequireDefault(require("@material-ui/core/Snackbar"));

var _SnackbarContent = _interopRequireDefault(require("@material-ui/core/SnackbarContent"));

var _SnackbarItem = require("./SnackbarItem.styles");

var _SnackbarItem2 = require("./SnackbarItem.util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SnackbarItem =
/*#__PURE__*/
function (_Component) {
  _inherits(SnackbarItem, _Component);

  function SnackbarItem(props) {
    var _this;

    _classCallCheck(this, SnackbarItem);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SnackbarItem).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "handleClose", function (key) {
      return function (event, reason) {
        var _this$props = _this.props,
            onClose = _this$props.onClose,
            singleOnClose = _this$props.snack.onClose;
        if (reason === 'clickaway') return;
        if (singleOnClose) singleOnClose(event, reason, key);
        onClose(event, reason, key);
      };
    });

    _defineProperty(_assertThisInitialized(_this), "handleExited", function (key) {
      return function (event) {
        var _this$props2 = _this.props,
            onExited = _this$props2.onExited,
            singleOnExited = _this$props2.snack.onExited;
        if (singleOnExited) singleOnExited(event, key);
        onExited(event, key);
      };
    });

    _defineProperty(_assertThisInitialized(_this), "componentDidMount", function () {
      var _this$props3 = _this.props,
          onSetHeight = _this$props3.onSetHeight,
          snack = _this$props3.snack;
      var height = _this.ref.current && _this.ref.current.clientHeight;
      onSetHeight(snack.key, height);
    });

    _this.ref = _react["default"].createRef();
    return _this;
  }

  _createClass(SnackbarItem, [{
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          classes = _this$props4.classes,
          action = _this$props4.action,
          anchorOrigin = _this$props4.anchorOrigin,
          _this$props4$ContentP = _this$props4.ContentProps,
          ContentProps = _this$props4$ContentP === void 0 ? {} : _this$props4$ContentP,
          hideIconVariant = _this$props4.hideIconVariant,
          preventDuplicate = _this$props4.preventDuplicate,
          iconVariant = _this$props4.iconVariant,
          offset = _this$props4.offset,
          snack = _this$props4.snack,
          style = _this$props4.style,
          onSetHeight = _this$props4.onSetHeight,
          other = _objectWithoutProperties(_this$props4, ["classes", "action", "anchorOrigin", "ContentProps", "hideIconVariant", "preventDuplicate", "iconVariant", "offset", "snack", "style", "onSetHeight"]);

      var contentAction = ContentProps.action,
          className = ContentProps.className,
          otherContentProps = _objectWithoutProperties(ContentProps, ["action", "className"]);

      var key = snack.key,
          persist = snack.persist,
          _snack$variant = snack.variant,
          variant = _snack$variant === void 0 ? 'default' : _snack$variant,
          singleAction = snack.action,
          _snack$ContentProps = snack.ContentProps,
          singleContentProps = _snack$ContentProps === void 0 ? {} : _snack$ContentProps,
          singleSnackProps = _objectWithoutProperties(snack, ["key", "persist", "variant", "action", "ContentProps"]);

      var icon = iconVariant[variant];

      var contentProps = _objectSpread({}, otherContentProps, singleContentProps, {
        action: singleAction || singleContentProps.action || contentAction || action
      });

      var anchOrigin = singleSnackProps.anchorOrigin || anchorOrigin;
      var finalAction = contentProps.action;

      if (typeof finalAction === 'function') {
        finalAction = contentProps.action(key);
      }

      var snackChildren = snack.children;

      if (snackChildren && typeof snackChildren === 'function') {
        snackChildren = snackChildren(key);
      }

      return _react["default"].createElement(_RootRef["default"], {
        rootRef: this.ref
      }, _react["default"].createElement(_Snackbar["default"], _extends({
        anchorOrigin: anchOrigin,
        TransitionProps: {
          direction: (0, _SnackbarItem2.getTransitionDirection)(anchOrigin)
        },
        style: _objectSpread({}, style, (0, _SnackbarItem.getTransitionStyles)(offset, anchOrigin))
      }, other, singleSnackProps, {
        open: snack.open,
        classes: (0, _SnackbarItem2.getMuiClasses)(classes),
        onClose: this.handleClose(key),
        onExited: this.handleExited(key)
      }), snackChildren || _react["default"].createElement(_SnackbarContent["default"], _extends({
        className: (0, _classnames["default"])(classes.base, classes["variant".concat((0, _SnackbarItem2.capitalise)(variant))], !hideIconVariant && icon ? classes.lessPadding : null, className)
      }, contentProps, {
        "aria-describedby": "client-snackbar",
        message: _react["default"].createElement("span", {
          id: "client-snackbar",
          className: classes.message
        }, !hideIconVariant ? icon : null, snack.message),
        action: finalAction
      }))));
    }
  }]);

  return SnackbarItem;
}(_react.Component);

SnackbarItem.propTypes = {
  classes: _propTypes["default"].object.isRequired,
  offset: _propTypes["default"].number.isRequired,
  snack: _propTypes["default"].shape({
    message: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].node]).isRequired,
    variant: _propTypes["default"].oneOf(['default', 'error', 'success', 'warning', 'info']),
    key: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]).isRequired,
    open: _propTypes["default"].bool.isRequired
  }).isRequired,
  iconVariant: _propTypes["default"].shape({
    success: _propTypes["default"].any.isRequired,
    warning: _propTypes["default"].any.isRequired,
    error: _propTypes["default"].any.isRequired,
    info: _propTypes["default"].any.isRequired
  }).isRequired,
  hideIconVariant: _propTypes["default"].bool.isRequired,
  preventDuplicate: _propTypes["default"].bool.isRequired,
  onSetHeight: _propTypes["default"].func.isRequired,
  onClose: _propTypes["default"].func.isRequired,
  onExited: _propTypes["default"].func.isRequired
};

var _default = (0, _styles.withStyles)(_SnackbarItem.styles)(SnackbarItem);

exports["default"] = _default;