"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTransitionStyles = exports.styles = void 0;

var _green = _interopRequireDefault(require("@material-ui/core/colors/green"));

var _amber = _interopRequireDefault(require("@material-ui/core/colors/amber"));

var _SnackbarItem = require("./SnackbarItem.util");

var _constants = require("../utils/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = function styles(theme) {
  return _objectSpread({}, _SnackbarItem.muiClasses, {
    base: {
      fontSize: '0.875rem',
      lineHeight: '1.46429em',
      fontWeight: theme.typography.fontWeightRegular,
      fontFamily: theme.typography.fontFamily
    },
    lessPadding: {
      paddingLeft: 8 * 2.5
    },
    variantSuccess: {
      backgroundColor: _green["default"][600]
    },
    variantError: {
      backgroundColor: theme.palette.error.dark
    },
    variantInfo: {
      backgroundColor: '#2979ff' // nice blue

    },
    variantWarning: {
      backgroundColor: _amber["default"][700]
    },
    message: {
      display: 'flex',
      alignItems: 'center'
    }
  });
};
/**
 * @param {object} anchorOrigin - how snack is postioned. e.g.
 * { vertical: 'bottom', horizontal: 'left' }
 * @param {number} level - Level on which snakcbar should be displayed
 * (when snackbars are stacked on top of eachother)
 * @returns {object}
 */


exports.styles = styles;

var getTransitionStyles = function getTransitionStyles(offset, anchorOrigin) {
  return Object.assign(_defineProperty({}, anchorOrigin.vertical, offset), {
    WebKitTransition: "all ".concat(_constants.TRANSITION_DOWN_DURATION, "ms"),
    MozTransition: "all ".concat(_constants.TRANSITION_DOWN_DURATION, "ms"),
    msTransition: "all ".concat(_constants.TRANSITION_DOWN_DURATION, "ms"),
    OTransition: "all ".concat(_constants.TRANSITION_DOWN_DURATION, "ms"),
    transition: "all ".concat(_constants.TRANSITION_DOWN_DURATION, "ms"),
    transitionDelay: "".concat(_constants.TRANSITION_DELAY, "ms")
  });
};

exports.getTransitionStyles = getTransitionStyles;