"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Slide = _interopRequireDefault(require("@material-ui/core/Slide"));

var _SnackbarContext = _interopRequireDefault(require("./SnackbarContext"));

var _constants = require("./utils/constants");

var _SnackbarItem = _interopRequireDefault(require("./SnackbarItem"));

var _warning = _interopRequireDefault(require("./utils/warning"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SnackbarProvider =
/*#__PURE__*/
function (_Component) {
  _inherits(SnackbarProvider, _Component);

  function SnackbarProvider(props) {
    var _this;

    _classCallCheck(this, SnackbarProvider);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SnackbarProvider).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "queue", []);

    _defineProperty(_assertThisInitialized(_this), "handleEnqueueSnackbar", function (message) {
      var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var key = _ref.key,
          preventDuplicate = _ref.preventDuplicate,
          options = _objectWithoutProperties(_ref, ["key", "preventDuplicate"]);

      if (preventDuplicate || _this.props.preventDuplicate) {
        var inQueue = _this.queue.findIndex(function (item) {
          return item.message === message;
        }) > -1;
        var inView = _this.state.snacks.findIndex(function (item) {
          return item.message === message;
        }) > -1;

        if (inQueue || inView) {
          return null;
        }
      }

      var id = key || new Date().getTime() + Math.random();

      var snack = _objectSpread({
        key: id,
        message: message
      }, options, {
        open: true
      });

      if (options.persist) {
        snack.autoHideDuration = undefined;
      }

      _this.queue.push(snack);

      _this.handleDisplaySnack();

      return id;
    });

    _defineProperty(_assertThisInitialized(_this), "handleDisplaySnack", function () {
      var maxSnack = _this.props.maxSnack;
      var snacks = _this.state.snacks;

      if (snacks.length >= maxSnack) {
        return _this.handleDismissOldest();
      }

      return _this.processQueue();
    });

    _defineProperty(_assertThisInitialized(_this), "processQueue", function () {
      if (_this.queue.length > 0) {
        var newOne = _this.queue.shift();

        _this.setState(function (_ref2) {
          var snacks = _ref2.snacks;
          return {
            snacks: [].concat(_toConsumableArray(snacks), [newOne])
          };
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleDismissOldest", function () {
      var popped = false;
      var ignore = false;

      var persistentCount = _this.state.snacks.reduce(function (acc, current) {
        return acc + (current.open && current.persist ? 1 : 0);
      }, 0);

      if (persistentCount === _this.props.maxSnack) {
        (0, _warning["default"])(_constants.MESSAGES.NO_PERSIST_ALL);
        ignore = true;
      }

      _this.setState(function (_ref3) {
        var snacks = _ref3.snacks;
        return {
          snacks: snacks.filter(function (item) {
            return item.open === true;
          }).map(function (item) {
            if (!popped && (!item.persist || ignore)) {
              popped = true;
              if (item.onClose) item.onClose(null, 'maxsnack', item.key);
              if (_this.props.onClose) _this.props.onClose(null, 'maxsnack', item.key);
              return _objectSpread({}, item, {
                open: false
              });
            }

            return _objectSpread({}, item);
          })
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleCloseSnack", function (event, reason, key) {
      _this.setState(function (_ref4) {
        var snacks = _ref4.snacks;
        return {
          snacks: snacks.map(function (item) {
            return !key || item.key === key ? _objectSpread({}, item, {
              open: false
            }) : _objectSpread({}, item);
          })
        };
      });

      if (_this.props.onClose) _this.props.onClose(event, reason, key);
    });

    _defineProperty(_assertThisInitialized(_this), "handleDismissSnack", function (key) {
      _this.handleCloseSnack(null, null, key);
    });

    _defineProperty(_assertThisInitialized(_this), "handleExitedSnack", function (event, key) {
      var enterDelay = _constants.TRANSITION_DELAY + _constants.TRANSITION_DOWN_DURATION + 40;

      _this.setState(function (_ref5) {
        var snacks = _ref5.snacks;
        return {
          snacks: snacks.filter(function (item) {
            return item.key !== key;
          })
        };
      }, function () {
        return setTimeout(_this.handleDisplaySnack, enterDelay);
      });

      if (_this.props.onExited) _this.props.onExited(event, key);
    });

    _defineProperty(_assertThisInitialized(_this), "handleSetHeight", function (key, height) {
      _this.setState(function (_ref6) {
        var snacks = _ref6.snacks;
        return {
          snacks: snacks.map(function (item) {
            return item.key === key ? _objectSpread({}, item, {
              height: height
            }) : _objectSpread({}, item);
          })
        };
      });
    });

    _this.state = {
      snacks: [],
      contextValue: {
        handleEnqueueSnackbar: _this.handleEnqueueSnackbar,
        handleCloseSnackbar: _this.handleDismissSnack
      }
    };
    return _this;
  }

  _createClass(SnackbarProvider, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          children = _this$props.children,
          maxSnack = _this$props.maxSnack,
          dense = _this$props.dense,
          props = _objectWithoutProperties(_this$props, ["children", "maxSnack", "dense"]);

      var _this$state = this.state,
          contextValue = _this$state.contextValue,
          snacks = _this$state.snacks;
      return _react["default"].createElement(_SnackbarContext["default"].Provider, {
        value: contextValue
      }, children, snacks.map(function (snack, index) {
        return _react["default"].createElement(_SnackbarItem["default"], _extends({}, props, {
          key: snack.key,
          snack: snack,
          offset: _this2.offsets[index],
          onClose: _this2.handleCloseSnack,
          onExited: _this2.handleExitedSnack,
          onSetHeight: _this2.handleSetHeight
        }));
      }));
    }
  }, {
    key: "offsets",
    get: function get() {
      var _this3 = this;

      var snacks = this.state.snacks;
      return snacks.map(function (item, i) {
        var index = i;

        var _ref7 = _this3.props.dense ? {
          view: 0,
          snackbar: 4
        } : {
          view: 20,
          snackbar: 12
        },
            viewOffset = _ref7.view,
            snackbarOffset = _ref7.snackbar;

        var offset = viewOffset;

        while (snacks[index - 1]) {
          var snackHeight = snacks[index - 1].height || 48;
          offset += snackHeight + snackbarOffset;
          index -= 1;
        }

        return offset;
      });
    }
    /**
     * Adds a new snackbar to the queue to be presented.
     * @param {string} message - text of the notification
     * @param {object} options - additional options for the snackbar we want to enqueue.
     * We can pass Material-ui Snackbar props for individual customisation.
     * @param {string} options.key
     * @param {string} options.variant - type of the snackbar. default value is 'default'.
     * can be: (default, success, error, warning, info)
     * @param {bool} options.persist
     * @param {bool} options.preventDuplicate
     * @returns generated or user defined key referencing the new snackbar or null
     */

  }]);

  return SnackbarProvider;
}(_react.Component);

SnackbarProvider.propTypes = {
  /**
   * Most of the time, this is your App. every component from this point onward
   * will be able to show snackbars.
   */
  children: _propTypes["default"].node.isRequired,

  /**
   * Override or extend the styles applied to the component.
   */
  classes: _propTypes["default"].object,

  /**
   * Maximum snackbars that can be stacked on top of one another.
   */
  maxSnack: _propTypes["default"].number,

  /**
   * Denser margins for snackbars. Recommended to be used on mobile devices
   */
  dense: _propTypes["default"].bool,

  /**
   * Ignores displaying multiple snackbars with the same `message`
   */
  preventDuplicate: _propTypes["default"].bool,

  /**
   * Hides iconVariant if set to `true`.
   */
  hideIconVariant: _propTypes["default"].bool,

  /**
   * Little icon that is displayed at left corner of a snackbar.
   */
  iconVariant: _propTypes["default"].shape({
    /**
     * Icon displayed when variant of a snackbar is set to `success`.
     */
    success: _propTypes["default"].any.isRequired,

    /**
     * Icon displayed when variant of a snackbar is set to `warning`.
     */
    warning: _propTypes["default"].any.isRequired,

    /**
     * Icon displayed when variant of a snackbar is set to `error`.
     */
    error: _propTypes["default"].any.isRequired,

    /**
     * Icon displayed when variant of a snackbar is set to `info`.
     */
    info: _propTypes["default"].any.isRequired
  }),

  /**
   * Callback to get action(s). actions are mostly buttons displayed in Snackbar.
   * @param {string|number} key key of a snackbar
   */
  action: _propTypes["default"].func,

  /**
   * The anchor of the `Snackbar`.
   */
  anchorOrigin: _propTypes["default"].shape({
    horizontal: _propTypes["default"].oneOf(['left', 'center', 'right']).isRequired,
    vertical: _propTypes["default"].oneOf(['top', 'bottom']).isRequired
  }),

  /**
   * The number of milliseconds to wait before automatically calling the
   * `onClose` function. `onClose` should then set the state of the `open`
   * prop to hide the Snackbar. This behavior is disabled by default with
   * the `null` value.
   */
  autoHideDuration: _propTypes["default"].number,

  /**
   * If `true`, the `autoHideDuration` timer will expire even if the window is not focused.
   */
  disableWindowBlurListener: _propTypes["default"].bool,

  /**
   * Callback fired when the component requests to be closed.
   * The `reason` parameter can optionally be used to control the response to `onClose`,
   * for example ignoring `clickaway`.
   *
   * @param {object} event The event source of the callback
   * @param {string} reason Can be:`"timeout"` (`autoHideDuration` expired) or: `"clickaway"`
   *  or: `"maxsnack"` (snackbar is closed because `maxSnack` has reached.)
   * @param {string|number} key key of a Snackbar
   */
  onClose: _propTypes["default"].func,

  /**
   * Callback fired before the transition is entering.
   */
  onEnter: _propTypes["default"].func,

  /**
   * Callback fired when the transition has entered.
   */
  onEntered: _propTypes["default"].func,

  /**
   * Callback fired when the transition is entering.
   */
  onEntering: _propTypes["default"].func,

  /**
   * Callback fired before the transition is exiting.
   */
  onExit: _propTypes["default"].func,

  /**
   * Callback fired when the transition has exited.
   */
  onExited: _propTypes["default"].func,

  /**
   * Callback fired when the transition is exiting.
   */
  onExiting: _propTypes["default"].func,

  /**
   * The number of milliseconds to wait before dismissing after user interaction.
   * If `autoHideDuration` property isn't specified, it does nothing.
   * If `autoHideDuration` property is specified but `resumeHideDuration` isn't,
   * we default to `autoHideDuration / 2` ms.
   */
  resumeHideDuration: _propTypes["default"].number,

  /**
   * The component used for the transition.
   */
  TransitionComponent: _propTypes["default"].elementType,

  /**
   * The duration for the transition, in milliseconds.
   * You may specify a single timeout for all transitions, or individually with an object.
   */
  transitionDuration: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].shape({
    enter: _propTypes["default"].number,
    exit: _propTypes["default"].number
  })])
};
SnackbarProvider.defaultProps = {
  maxSnack: 3,
  dense: false,
  preventDuplicate: false,
  hideIconVariant: false,
  iconVariant: _constants.iconVariant,
  anchorOrigin: {
    vertical: 'bottom',
    horizontal: 'left'
  },
  autoHideDuration: 5000,
  TransitionComponent: _Slide["default"]
};
var _default = SnackbarProvider;
exports["default"] = _default;