function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import green from '@material-ui/core/colors/green';
import amber from '@material-ui/core/colors/amber';
import { muiClasses } from './SnackbarItem.util';
import { TRANSITION_DELAY, TRANSITION_DOWN_DURATION } from '../utils/constants';
export var styles = function styles(theme) {
  return _objectSpread({}, muiClasses, {
    base: {
      fontSize: '0.875rem',
      lineHeight: '1.46429em',
      fontWeight: theme.typography.fontWeightRegular,
      fontFamily: theme.typography.fontFamily
    },
    lessPadding: {
      paddingLeft: 8 * 2.5
    },
    variantSuccess: {
      backgroundColor: green[600]
    },
    variantError: {
      backgroundColor: theme.palette.error.dark
    },
    variantInfo: {
      backgroundColor: '#2979ff' // nice blue

    },
    variantWarning: {
      backgroundColor: amber[700]
    },
    message: {
      display: 'flex',
      alignItems: 'center'
    }
  });
};
/**
 * @param {object} anchorOrigin - how snack is postioned. e.g.
 * { vertical: 'bottom', horizontal: 'left' }
 * @param {number} level - Level on which snakcbar should be displayed
 * (when snackbars are stacked on top of eachother)
 * @returns {object}
 */

export var getTransitionStyles = function getTransitionStyles(offset, anchorOrigin) {
  return Object.assign(_defineProperty({}, anchorOrigin.vertical, offset), {
    WebKitTransition: "all ".concat(TRANSITION_DOWN_DURATION, "ms"),
    MozTransition: "all ".concat(TRANSITION_DOWN_DURATION, "ms"),
    msTransition: "all ".concat(TRANSITION_DOWN_DURATION, "ms"),
    OTransition: "all ".concat(TRANSITION_DOWN_DURATION, "ms"),
    transition: "all ".concat(TRANSITION_DOWN_DURATION, "ms"),
    transitionDelay: "".concat(TRANSITION_DELAY, "ms")
  });
};