function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import hoistNonReactStatics from 'hoist-non-react-statics';
import getDisplayName from './utils/getDisplayName';
import SnackbarContext from './SnackbarContext';

var withSnackbar = function withSnackbar(Component) {
  var WrappedComponent = React.forwardRef(function (props, ref) {
    return React.createElement(SnackbarContext.Consumer, null, function (context) {
      return React.createElement(Component, _extends({}, props, {
        ref: ref,
        enqueueSnackbar: context.handleEnqueueSnackbar,
        closeSnackbar: context.handleCloseSnackbar
      }));
    });
  });

  if (process.env.NODE_ENV !== 'production') {
    WrappedComponent.displayName = "WithSnackbar(".concat(getDisplayName(Component), ")");
  }

  hoistNonReactStatics(WrappedComponent, Component);
  return WrappedComponent;
};

export default withSnackbar;